import com.cattura.agents.configuration_module.model.interfaces.Plugin;
import com.cattura.agents.configuration_module.model.interfaces.Plugin.Inject;
import com.cattura.agents.configuration_module.model.interfaces.Plugin.On;
import com.cattura.agents.configuration_module.model.vos.plugin.PluginInfo;
import com.cattura.agents.configuration_module.model.interfaces.Observer.Observes;
import java.io.File;
import org.puremvc.java.multicore.patterns.facade.Facade
import com.cattura.agents.configuration_module.model.proxies.EnvironmentProxy
import com.cattura.agents.configuration_module.model.vos.events.Event
import com.cattura.agents.configuration_module.model.interfaces.User.Role

class MediaInfoPlugin implements Plugin
{
    private static final def ANALYZERS = [
        mediainfo: "mediainfo --output=html {mediaFile}",
        atomicparsley: "AtomicParsley {mediaFile} -T",
        ffprobe: "ffprobe {mediaFile}"
    ];
    public static @Inject.Info PluginInfo _info;
    public static @Inject.Facade Facade _facade;
    
    private static final List ALLOWED_ROLES = ["Content manager"]
    private static final String PERMISSION = "analyze media"    
    
    @On.Load
    public void onLoad ()
    {
        _info.getLogger().info("MediaInfo Plugin started")
        ALLOWED_ROLES.each() {
            Role.get(it).get().grant(PERMISSION)
        }
    }
    
    @Observes
    public void onEvent (final Event $event)
    {
        if ($event.getClass().getSimpleName() == "WebServerEvent")
        {
            def MediaInfoHttpHandler = this.class.classLoader.parseClass(_info.getResource("MediaInfoHttpHandler.groovy"))
            System.err.println(MediaInfoHttpHandler)
            $event.getWebServer().add(MediaInfoHttpHandler.newInstance(
                _facade.retrieveProxy(EnvironmentProxy.NAME),
                ANALYZERS
            ))
        }
    }
}

plugin = new MediaInfoPlugin()